import json
import random

data = json.loads(open("tree.json", 'r').read())

n = len(data['nodes'])
k = 30
C = 100
c = {}
for node in data['nodes']:
    if node['id'] not in c.keys():
        c[node['id']] = []
    if node['parent_id'] not in c.keys():
        c[node['parent_id']] = [node['id']]
    else:
        c[node['parent_id']].append(node['id'])

print(c)
res = ["Minimize"]
obj = "obj: "
for i in range(n):
    for j in range(n):
        for v in range(k):
            obj += str(random.randint(1, 100)) + "x_" + str(i) + "_" + str(j) + "_" + str(v) + "+"

res.append(obj[:-1])

res.append("Subject to")

for v in range(k):
    for node in data['nodes']:
        if node['parent_id'] is None:
            continue
        for j in c[node["id"]]:
            res.append("x_" + str(node['parent_id']) + "_" + str(node['id']) + "_" + str(v) + "-" + "x_" + str(
                node['id']) + "_" + str(j) + "_" + str(v) + ">= 0")

for v in range(k):
    for node in data['nodes']:
        if node['parent_id'] is None:
            continue
        res.append("x_" + str(node['parent_id']) + "_" + str(node['id']) + "_" + str(v) + "-" + "y_" + str(
                node['id']) + "_" + str(v) + ">= 0")

for v in range(k):
    t = ""
    for node in data['nodes']:
        t += str(node['capacity']) + "y_" + str(node['id']) + "_" + str(v) + "-"
    res.append("-" + t[:-1] + ">= -"+str(C))

for node in data['nodes']:
    t = ""
    for v in range(k):
        t += "y_" + str(node['id']) + "_" + str(v) + "+"
    res.append(t[:-1] + "= 1")
res.append("Binary")

for i in range(n):
    for j in range(n):
        for v in range(k):
            res.append("x_" + str(i) + "_" + str(j) + "_" + str(v))
# remove it for split delivery
# for v in range(k):
#     for node in data['nodes']:
#         res.append("y_" + str(node['id']) + "_" + str(v))

res.append('END')
open('cplex2.lp', 'w').write('\n'.join(res))